% J.C.F. de Winter, j.c.f.dewinter@tudelft.nl
% Tested in MATLAB R2016a
clear variables;close all;clc
TH=25;
one96=max(norminv([0.025, 0.975])); % 1.96
[~,~,raw]=xlsread('f891680-5_r3.xls','A3:DV10002');
X=NaN(size(raw,1),88);

for i=1:size(raw,1);
    X(i,1)=24*3600*(datenum(raw(i,2),'mm/dd/yyyy HH:MM:SS')-datenum(raw(i,4),'mm/dd/yyyy HH:MM:SS')); % survey completion time
    X(i,2:3)=datenum(raw(i,[2 4]),'mm/dd/yyyy HH:MM:SS')';
end
X(:,1)=tiedrank(X(:,1))./size(X,1); % normalize survey time to make it comparable between surveys.

temp=raw(:,121);X(:,5)=1*strcmp(temp,'female')+2*strcmp(temp,'male')-1*strcmp(temp,'i_prefer_not_to_respond'); % Gender
temp=raw(:,9);Country=cell(size(raw,1),1);for i=1:length(temp);try Country(i)=unique(temp(i));catch error;Country(i)={'NaN'};end;end % Country
temp=raw(:,39); X(:,6)=strcmp(temp,'no')+2*strcmp(temp,'yes'); % Instructions understood
%IP=NaN(size(raw,1),1);for i=1:size(raw,1);try IP(i)=str2double(strrep(raw(i,12),'.',''));catch;IP(i)=cell2mat(raw(i,12));end;end % reduce IP addresses of CrowdFlower to a single number
d={'Agree'  %5
    'Disagree' % 2
    'agree_somewhat'  %4
    'disagree_somewhat'  % 3
    'i_prefer_not_to_respond'
    'strongly_agree' % 6
    'strongly_disagree'}; % 1
IU=NaN(126,1);
for i=1:126
    try IU(i)=isequal(unique(raw(1:1000,i)),d);catch error;end
end
X(:,7:54)=strcmp(raw(:,IU==1),'strongly_disagree')+2*strcmp(raw(:,IU==1),'Disagree')+3*strcmp(raw(:,IU==1),'disagree_somewhat')+4*strcmp(raw(:,IU==1),'agree_somewhat')+5*strcmp(raw(:,IU==1),'Agree')+6*strcmp(raw(:,IU==1),'strongly_agree')-1*strcmp(raw(:,IU==1),'i_prefer_not_to_respond');
for i=1:size(X,1);
    try
        X(i,55)=[1*cell2mat(strfind(raw(i,103),'Below 1000$ per month'))
            2*cell2mat(strfind(raw(i,103),'1.000$ up to 1.599$'))
            3*cell2mat(strfind(raw(i,103),'1.600$ up to 2.899$'))
            4*cell2mat(strfind(raw(i,103),'2.900$ up to 3.999$'))
            5*cell2mat(strfind(raw(i,103),'4.000$ up to 5.000$'))
            6*cell2mat(strfind(raw(i,103),'More than 5.000$'))
            -1*cell2mat(strfind(raw(i,103),'i_prefer_not_to_respond'))];
    catch error
        X(i,55)=-1;
    end
end
for i=1:size(X);try X(i,56)=cell2mat(raw(i,26));catch error;X(i,56)=NaN;end;end % distance_from_workplace_miles
for i=1:size(X);try X(i,57)=cell2mat(raw(i,42));catch error;X(i,57)=4*strcmp(raw(i,42),'more_than_3')+-1*strcmp(raw(i,42),'i_prefer_not_to_respond');end;end % how_many_vehicles_do_you_have_in_your_household
temp=raw(:,41); X(:,58)=strcmp(temp,'less than 5 minutes')+2*strcmp(temp,'between 5 to 10 minutes')+3*strcmp(temp,'between 10 to 20 minutes')+4*strcmp(temp,'between 20 to 30 minutes')+5*strcmp(temp,'more than 30 minutes')-1*strcmp(temp,'i_prefer_not_to_respond')-2*strcmp(temp,'not walkable');
for i=1:size(X);try X(i,59)=cell2mat(raw(i,126));catch error;end;end % younger_than_6_years_old
for i=1:size(X);try X(i,60)=cell2mat(raw(i,14));catch error;end;end % 6_to_13_years_old
for i=1:size(X);try X(i,61)=cell2mat(raw(i,13));catch error;end;end % 14_to_17_years_old
for i=1:size(X);try X(i,62)=cell2mat(raw(i,99));catch error;end;end % over_18_years
no_other=strcmp(raw(:,21),'true');X(sum(isnan(X(:,59:62)),2)==4 & no_other==1,59:62)=0; % if no other ticked, then 0
X(X(:,59)>10,59)=NaN; % more than 10 people in household in age category is deemed impossible
X(X(:,60)>10,60)=NaN;
X(X(:,61)>10,61)=NaN;
X(X(:,62)>10,62)=NaN;
% for i=1:size(X); % age
%     try X(i,63)=2016-cell2mat(raw(i,17));
%     catch error
%         for i2=1905:2005;
%             if cell2mat(strfind(raw(i,17),num2str(i2)));
%                 X(i,63)=2016-i2;
%             end
%         end
%     end
% end
% Age_temp=X(:,63);
% save('Age.mat','Age_temp');
load Age.mat
X(:,63)=Age_temp;
temp=raw(:,18); X(:,64)=strcmp(temp,'no')+2*strcmp(temp,'yes')-1*strcmp(temp,'i_prefer_not_to_respond'); % an_external_control_room_may_monitor_the_operations_of_the_driverless_vehicle_for_safety_reasons_no_private_data_will_be_collected_from_you_would_you_mind_being_transported_by_a_driverless_vehicle_that_is_supervised_by_an_external_control_room
for i=1:size(X);try X(i,65)=cell2mat(raw(i,20));catch error;X(i,65)=NaN;end;end % annual_mileage_in_miles
temp=raw(:,22); X(:,66)=strcmp(temp,'I do not experience motion sickness')+2*strcmp(temp,'moderate')+3*strcmp(temp,'severe')-1*strcmp(temp,'i_prefer_not_to_respond'); % Please indicate the severity of motion sickness you experience in a moving conventional vehicle or when taking public transport means. (required) PROBLEM QUESTION

d={'I do not know'
    'I would not appreciate this development at all'
    'I would rather appreciate this development'
    'I would rather not appreciate this development'
    'agree_somewhat'
    'i_prefer_not_to_respond'};
IU=NaN(126,1);
for i=1:126
    try IU(i)=isequal(unique(raw(1:1000,i)),d);catch error;end % look up which items use this
end
X(:,67:70)=strcmp(raw(:,IU==1),'I would not appreciate this development at all')+2*strcmp(raw(:,IU==1),'I would rather not appreciate this development')+3*strcmp(raw(:,IU==1),'I would rather appreciate this development')+4*strcmp(raw(:,IU==1),'agree_somewhat')-2*strcmp(raw(:,IU==1),'I do not know')-1*strcmp(raw(:,IU==1),'i_prefer_not_to_respond');
% 66. city_centers_will_be_closed_to_cartraffic
% 67. in_cities_electric_vehicles_will_completely_replace_combustion_engines_within_the_next_2030_years
% 68. most_roads_and_streets_in_the_cities_will_be_redesigned_to_privilege_pedestrians_bicycles_and_public_transport
% 69. there_will_be_many_carfree_neighborhoods_where_car_use_is_only_allowed_exceptionally_and_no_car_parking_space_is_provided

d={    'Daily_or_almost_daily'
    'i_prefer_not_to_respond'
    'less_than_monthly_or'
    'never_or_almost_never'
    'on_one_to_three_days_per_month'
    'on_one_to_three_days_per_week'};
IU=NaN(126,1);
for i=1:126
    try IU(i)=isequal(unique(raw(1:1000,i)),d);catch error;end
end
X(:,71:77)=strcmp(raw(:,IU==1),'never_or_almost_never')+2*strcmp(raw(:,IU==1),'less_than_monthly_or')+3*strcmp(raw(:,IU==1),'on_one_to_three_days_per_month')+4*strcmp(raw(:,IU==1),'on_one_to_three_days_per_week')+5*strcmp(raw(:,IU==1),'Daily_or_almost_daily')-1*strcmp(raw(:,IU==1),'i_prefer_not_to_respond');
d={ 'i_prefer_not_to_respond'
    'no'
    'yes'};
IU=NaN(126,1);
for i=1:126
    try IU(i)=isequal(unique(raw(1:1000,i)),d);catch error;end
end
IU(18)=0;
X(:,78:79)=strcmp(raw(:,IU==1),'no')+2*strcmp(raw(:,IU==1),'yes')-1*strcmp(raw(:,IU==1),'i_prefer_not_to_respond');
% 78 do_you_have_a_monthly_pass_or_an_annual_travel_card_for_public_transport
% 79 = do_you_have_a_valid_drivers_license
for i=1:size(X);try X(i,80)=4-cell2mat(raw(i,40));catch error;X(i,82)=-1*strcmp(raw(i,80),'i_prefer_not_to_respond')-2*strcmp(raw(i,80),'Do not own or use vehicle');end;end % in_how_many_accidents_were_you_involved_in_when_driving_a_vehicle_in_the_last_3_years_please_indicate_all_accidents_regardless_of_how_they_were_caused_how_severe_they_were_or_where_they_happened
for i=1:size(X);try X(i,81)=cell2mat(raw(i,80));catch error;X(i,82)=-1*strcmp(raw(i,80),'i_prefer_not_to_respond')+6*strcmp(raw(i,80),'more_than_5');end;end % in_how_many_accidents_were_you_involved_in_when_driving_a_vehicle_in_the_last_3_years_please_indicate_all_accidents_regardless_of_how_they_were_caused_how_severe_they_were_or_where_they_happened
for i=1:size(X);try X(i,82)=cell2mat(raw(i,81));catch error;X(i,83)=-1*strcmp(raw(i,81),'i_prefer_not_to_respond')+3*strcmp(raw(i,81),'More than 2');end;end % in_how_many_carsharing_organizations_are_you_a_member
temp=raw(:,105); X(:,83)=strcmp(temp,'Never')+2*strcmp(temp,'When it is used by less than 5 % of the people')+3*strcmp(temp,'When it is used by 20% to 40% of the people')+4*strcmp(temp,'When it is used by 50% to 60% of the people')+5*strcmp(temp,'When it is used by 70% to 90% of the people')+6*strcmp(temp,'When it is used by 95% to 100% of the people')-1*strcmp(temp,'I prefer not to respond'); % Please indicate when you would use a driverless vehicle. Please select only the most relevant option to you.
temp=raw(:,108); X(:,84)=3*strcmp(temp,'the_number_of_parking_spaces_should_be_reduced_to_make_more_space_available_for_other_uses_eg_pedestrians_bike_parking_playgrounds_or_parks')+2*strcmp(temp,'the_number_of_parking_spaces_should_stay_as_it_is')+1*strcmp(temp,'all_parts_of_the_city_must_be_accessible_by_car_therefore_more_car_parking_space_should_be_provided'); % Please think of your own neighbourhood. Which of the following statements do you agree to most? Please select only one option (required)

d={  'I don''t know'
    'Probable'
    'Rather probable'
    'Rather unlikely'
    'Unlikely'
    'i_prefer_not_to_respond'};
IU=NaN(126,1);
for i=1:126
    try IU(i)=isequal(unique(raw(1:1000,i)),d);catch error;end
end
X(:,85:87)=strcmp(raw(:,IU==1),'Unlikely')+2*strcmp(raw(:,IU==1),'Rather unlikely')+3*strcmp(raw(:,IU==1),'Rather probable')+4*strcmp(raw(:,IU==1),'Probable')-1*strcmp(raw(:,IU==1),'i_prefer_not_to_respond')-2*strcmp(raw(:,IU==1),'I don''t know');
% 86 = selfdriving_vehicles_will_be_a_normal_part_of_everyday_mobility
% 87 = selfdriving_vehicles_will_mostly_be_privately_owned
% 88 = selfdriving_vehicles_will_mostly_be_shared_vehicles
temp=raw(:,124); X(:,88)=strcmp(temp,'Outside of the city in a house in the countryside')+2*strcmp(temp,'In a house on the city outskirts')+3*strcmp(temp,'Within the city, but outside the city centre in a purely residential area')+4*strcmp(temp,'In an appartment in the immediate city centre')-1*strcmp(temp,'i_prefer_not_to_respond'); % Please indicate when you would use a driverless vehicle. Please select only the most relevant option to you. Q7

invalid1=find(X(:,6)<2);   % respondents who did not read instructions or did not answer
invalid2=find(X(:,63)<18);  % respondents who indicated they are under 18 years old
invalid3=find(X(:,63)>110); % respondents who indicated they are above 110 years old
invalid4=find(isnan(sum(X(:,[5 63]),2)) | (sum(X(:,[5 63])==-1,2)>0)); % respondents with 'no response' to worker ID, gender, and age question
invalid5=find(strcmp(Country,'NaN')==1);
%y = NaN(size(X(:,1)));
%for i=1:size(X,1)
%    temp=find(IP==IP(i));
%    if length(temp)==1 % if the IP address occurs only once
%        y(i)=1; % keep
%    elseif length(temp)>1 % if the IP addres occurs more than once
%        y(temp(1))=1; % keep the first survey for that IP address
%        y(temp(2:end))=2; % no not keep the other ones
%    end
%end
%invalid6=find(y>1); % respondents who completed the survey more than once (i.e., remove the doublets), based on IP address
invalid6=[           2          14          22          34          35          82         253         541         542         642         660         788         986        1029        1063 ....
    1067        1304        1363        1393        1772        2033        2234        2236        2471        2606        3184        3246        3313        3337        3362....
    3620        3716        3849        3934        3969        4306        4412        4643        4661        4664        4754        4822        4845        4934        4983....
    5052        5122        5209        5260        5743        5828        5971        6111        6114        6224        6402        6418        6520        6760        6872....
    6938        6961        7226        7321        7329        7370        7469        7491        7516        7536        7552        7611        7674        7726        7731....
    7774        7801        7860        7898        7909        7927        8039        8050        8109        8132        8163        8164        8176        8225        8268....
    8274        8291        8339        8404        8410        8419        8422        8452        8462        8473        8495        8555        8591        8647        8659....
    8722        8778        8788        8840        8864        8879        8882        8888        8891        8895        8896        8898        8900        8901        8903....
    8908        8913        8929        8933        8938        8943        8944        8974        8995        9014        9027        9030        9032        9033        9160....
    9175        9199        9219        9220        9232        9243        9303        9314        9315        9318        9320        9326        9328        9335        9339....
    9345        9346        9351        9355        9367        9376        9381        9392        9398        9465        9479        9500        9779        9803        9820....
    9832        9841        9846        9972        9983        9991        9993]'; % respondents who completed the survey more than once (i.e., remove the doublets but keep the forced one in the list), based on IP address
invalid7=find(X(:,1)<.05);
invalid8=find(sum(X(:,[7:55 58 64 66:80 83:88])==0,2)>0);invalid8=[invalid8;9999];
invalid9=(find(sum(X<0,2)>=9)); % 9 or more missing items
invalid10=[find(X(:,28)==1 & X(:,40)==1);find(X(:,28)==2 & X(:,40)==2);find(X(:,28)==5& X(:,40)==5);find(X(:,28)==6 & X(:,40)==6)];
invalid11=find(nanstd(X(:,7:54),[],2)==1);
invalid=unique([invalid1;invalid2;invalid3;invalid4;invalid5;invalid6;invalid7;invalid8;invalid9;invalid10;invalid11]); % all invalid respondents
disp('Correlation before')
corr(X(:,40),X(:,28),'rows','pairwise')
X(invalid,:)=[];% remove invalid respondents
disp('Correlation after')
corr(X(:,40),X(:,28),'rows','pairwise')
Country(invalid)=[];
disp(['Number of respondents who did not read instructions: ' num2str(length(invalid1))])
disp(['Number of respondents under 18: ' num2str(length(invalid2))])
disp(['Number of respondents above 110: ' num2str(length(invalid3))])
disp(['Number of respondents with no response for gender or age: ' num2str(length(invalid4))])
disp(['Number of respondents with no country identified: ' num2str(length(invalid5))])
disp(['Number of respondents more than once from the same IP address: ' num2str(length(invalid6))])
disp(['Number of respondents faster than the fastest 5%: ' num2str(length(invalid7))])
disp(['Number of respondents with recording errors: ' num2str(length(invalid8))])
disp(['Number of respondents with 9 or more missing values (10% or over): ' num2str(length(invalid9))])
disp(['Number of respondents who report the same answer for Q28 & 40 (except moderate answers): ' num2str(length(invalid10))])
disp(['Number of respondents who report same answer throughout ' num2str(length(invalid11))])
disp(['Number of respondents in any of these categories: ' num2str(length(invalid))])
disp(['Number of respondents included in the analysis: ' num2str(size(X,1))]);
disp(['Number of countries included in the analysis: ' num2str(length(unique(Country)))])
pause
X(X(:,56)>250,56)=NaN; % more than 250 miles from work
X(X(:,65)>200000,65)=NaN; % more than 200000 miles per year
HST=histc(X(:,1:88),-2:6)';
X(X<0)=NaN;
%%
ID_ITU=[12 31 38 39 41 43 45 74];
ID=[7:11 13:30 32:37 40 42 44 46:51 53 54 64 67:70 74 83:87];
ID=unique([ID_ITU ID]);
X2=X(:,ID);
temp=X2;
X2=knnimpute(X2);
r=corr(X2); % replace NaNs with value from nearest-neighbor variable (column) for that participant (i.e., look for which variable is most similar)

temp2=NaN(size(X));temp2(:,ID)=temp;histc(temp2(:,[54 64]),1:5),corr(temp2(:,[54 64]),'rows','pairwise')% distribution of original data
X3=NaN(size(X));X3(:,ID)=X2;histc(X3(:,[54 64]),1:5),corr(X3(:,[54 64]),'rows','pairwise') % distribution of imputed data

lding=pcaj(r,1);
for i=1:size(lding,2);if mean(lding(:,i))<0;lding(:,i)=-lding(:,i);end;end
pc_scores = zscore(X2)/lding';
lding_X=NaN(size(X,2),1);
lding_X(ID,:)=lding;

lding5=pcaj(r,5);
lding5=rotatefactors(lding5,'method','promax');
for i=1:size(lding5,2);if mean(lding5(:,i))<0;lding5(:,i)=-lding5(:,i);end;end
pc_scores5 = zscore(X2)/lding5';
lding5_X=NaN(size(X,2),5);
lding5_X(ID,:)=lding5;
%%
eigr=sort(eig(r),'descend');
varexplained=100*(eigr./sum(eigr));
figure;plot(eigr,'k-o','Linewidth',3)

ylabel('Eigenvalue')
xlabel('Component number')
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial','Fontsize',24)
set(gca,'LooseInset', [0.01 0.01 0.01 0.01],'xtick',[1 5:5:100]);
set(gca,'xlim',[.5  length(r)+.5])
for i=1:5
    text(i+0.5,eigr(i),[sprintf('%0.1f',varexplained(i)) '%'],'color','b','fontsize',13);
end
saveas(gcf,'Figure_eigenvalues','fig');

iX = inv(r);
S2 = diag(diag((iX.^-1)));
AIS = S2*iX*S2;
Dai = diag(diag(sqrt(AIS)));
AIR = inv(Dai)*AIS*inv(Dai);
AA = sum(sum((AIR - diag(diag(AIR))).^2));
BB = sum(sum((r - eye(size(r))).^2));
kmo = BB/(AA+BB);
disp(['The Kaiser-Meyer-Olkin (KMO) measure of sampling adequacy was ' num2str(kmo)])
disp(['Cronbach''s alpha = ' num2str(cronbach(X2))])
disp(['Cronbach''s alpha GAC, 0.4 loading variables = ' num2str(cronbach(X2(:,lding>.4)))])
disp(['Cronbach''s alpha PCA 1, 0.4 loading variables = ' num2str(cronbach(X2(:,lding5(:,1)>.4)))])
disp(['Cronbach''s alpha PCA 2, 0.4 loading variables = ' num2str(cronbach(X2(:,lding5(:,2)>.4)))])
disp(['Cronbach''s alpha PCA 3, 0.4 loading variables = ' num2str(cronbach(X2(:,lding5(:,3)>.4)))])
disp(['Cronbach''s alpha PCA 4, 0.4 loading variables = ' num2str(cronbach(X2(:,lding5(:,4)>.4)))])
disp(['Cronbach''s alpha PCA 5, 0.4 loading variables = ' num2str(cronbach(X2(:,lding5(:,5)>.4)))])

X(:,89)=pc_scores;
X(:,90:94)=pc_scores5;
%% Country analysis
UC=unique(Country); % unique countries
NC=NaN(length(UC),1);
XCmed=NaN(length(UC),size(X,2));
XCmean=NaN(length(UC),size(X,2));
c_within=NaN(length(UC),size(X,2),size(pc_scores,2));
c_within5=NaN(length(UC),size(X,2),size(pc_scores5,2));

temp=double(char(Country));CountryCode=temp(:,1)*10000+temp(:,2)*100+temp(:,3); % convert country to number
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(Country,UC(i)));
    NC(i,1)=length(temp); % number of respondents per country
    XCmean(i,1:1:size(X,2))=nanmean(X(temp,:),1); % country's mean value
    XCmed(i,1:1:size(X,2))=nanmedian(X(temp,:),1); % country's median value 
    c_within(i,:,:)=corr(pc_scores(temp,:),X(temp,:),'rows','pairwise','type','spearman')'; % within country correlation between component scores and items
    c_within5(i,:,:)=corr(pc_scores5(temp,:),X(temp,:),'rows','pairwise','type','spearman')';
end
UC=UC(NC>=TH)';
disp(['Respondents came from ' num2str(size(NC,1)) ' different countries'])
%%
clc
clear publicdata
temp=unique(Country);temp=unique(temp(NC>=2));temp=ismember(Country,temp); % respondents from countries with 2 or more respondents
c_within_me=NaN(size(X,2),size(pc_scores,2));
for i=1:size(X,2);
try
    disp(i)
    me_data = table;
    me_data.GAC=nanzscore(tiedrank(pc_scores(temp)));
    me_data.X=nanzscore(tiedrank(X((temp),i)));
    me_data.Country=Country(temp);
    lm_groupe = fitlme(me_data,'X ~ -1 + GAC + (1+ GAC|Country)');
    temp2=lm_groupe.fixedEffects;
    c_within_me(i)=temp2(1); % estimate of fixed effects coefficient
catch error
end
end
%% Data taken from the WHO report "Global status report on road safety 2015"
[WHO_ndata,~,WHO_alldata]=xlsread('WHO_data_2015_all_countries.xlsx','A2:H184');
WHO_acc=NaN(length(UC),3);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(WHO_alldata(:,2),UC(i)));
    if isempty(temp)==0
        WHO_acc(i,1:3)=WHO_ndata(temp,4:6); % GDP
    end
end
%% Cognitive ability, data from Rindermann 2007
[COGN_ndata,~,COGN_alldata]=xlsread('Rindermann_2007_data.xlsx','A3:L196');
COGN=NaN(length(UC),1);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(COGN_alldata(:,2),UC(i)));if ~isempty(temp);COGN(i,1)=COGN_ndata(temp,9);end
end
%% Life expectancy, from Data WorldBank
[LIFE_ndata0,~,LIFE_alldata]=xlsread('life_expectancy.xlsx','B5:BF252');
LIFE_ndata=LIFE_ndata0(:,54);LIFE=NaN(length(UC),1);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(LIFE_alldata(:,1),UC(i)));if ~isempty(temp);LIFE(i,1)=LIFE_ndata(temp,1);end
end
%% Vehicle density, from Data WorldBank
[VEH_ndata0,~,VEH_alldata]=xlsread('Veh_density.xlsx','B4:L201');
VEH_ndata=nanmean(VEH_ndata0,2);VEH=NaN(length(UC),1);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(VEH_alldata(:,1),UC(i)));if ~isempty(temp);VEH(i,1)=VEH_ndata(temp,1);end
end
%% Median age, data taken from https://en.wikipedia.org/wiki/List_of_countries_by_median_age
[AGE_ndata0, AGE_text, AGE_alldata]=xlsread('median_age','A1:B230');
AGE_ndata=AGE_ndata0(:,1);
AGE=NaN(length(UC),1);
for i=1:length(UC) % loop across the unique countries
    temp=find(strcmp(AGE_alldata(:,1),UC(i)));if ~isempty(temp);AGE(i,1)=AGE_ndata(temp,1);end
end
%%
clc
disp('M, SD, Median, Max')
disp([nanmean(X)' nanstd(X)' nanmedian(X)']) 
%%
clc
disp('Histogram')
disp(HST)
%%
clc
disp('Loadings')
disp(lding_X)
%%
clc
disp('Loadings (5 components)')
disp(lding5_X)
%%
clc
disp('Spearman correlations with PCA scores')
c=corr(pc_scores,X,'rows','pairwise','type','spearman')';
c(ID,:)=NaN;
disp(c)
%%
clc
disp('Spearman correlations with PCA scores (5 components)')
c=corr(pc_scores5,X,'rows','pairwise','type','spearman')';
c(ID,:)=NaN;
disp(c)
%%
clc
disp('Correlations with PCA scores - within a country')
temp1=c_within(NC>=2,:);
temp2=repmat(NC(NC>=2),1,size(temp1,2));
c=nansum(temp1.*temp2,1)'./sum(temp2)';
c([6 ID])=NaN;
c_within_me([6 ID 89:end])=NaN;
disp(c)
disp('Correlation between within-country correlation and mixed effects result')
corr(c,c_within_me,'rows','pairwise')
%%
clc
disp('Correlations with PCA scores - within a country (5 components)')
temp1=c_within5(NC>=2,:,:); % within country correlations per coutry, variable, and 5 components
temp2=repmat(NC(NC>=2),1,size(temp1,2),5); % sample size per country
c=squeeze(nansum(temp1.*temp2,1))./squeeze(sum(temp2));
c([6 ID],:)=NaN;
disp(c)
%%
clc
disp('Partial correlations with PCA scores')
c=partialcorr(pc_scores,X,X(:,[1 52]),'rows','pairwise','type','spearman')';

c(ID,:)=NaN;
disp(c)

[cx,px]=partialcorr(nanzscore(tiedrank(pc_scores)),nanzscore(tiedrank(X(:,3))),nanzscore(tiedrank(X(:,[1 52]))),'rows','pairwise');
%%
clc
disp('Partial correlations with PCA scores (5 component)')
c=partialcorr(pc_scores5,X,X(:,[1 52]),'rows','pairwise','type','spearman')';
c(ID,:)=NaN;
disp(c)
%%
clc
disp('Country correlation with GDP (mean)')
[c,~]=corr(WHO_acc(:,3), XCmean(NC>=TH,:),'type','spearman','rows','pairwise');
disp(c')
%%
clc
disp('Country correlation with GDP (median)')
[c,~]=corr(WHO_acc(:,3), XCmed(NC>=TH,:),'type','spearman','rows','pairwise');
disp(c')

%% Figure 2 left. Scatter plot of GPD per capita versus mean general acceptance score
temp=XCmean(NC>=TH,89);
figure;hold on;set(gca,'xscale','log');
for i=1:size(WHO_acc,1)
    semilogx(WHO_acc(i,3),temp(i),'ks','MarkerFaceColor','none','MarkerEdgeColor',[0 0 1],'Markersize',10,'Linewidth',1.2)
end
h=findobj('FontName','Helvetica'); set(h,'FontSize',20,'Fontname','Arial')
xlabel('GDP per capita (US$, log scale)');ylabel('Mean general acceptance score')
axis([500 100000 -1 0.5])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial')
grid on;box on;axis square
set(gca,'LooseInset', [0.01 0.01 0.10 0.01]);
saveas(gcf,'Figure_GDPcapita_vs_general_acceptance','fig');
%% Figure 2 right. Scatter plot of GPD per capita versus mean thrill seeking score
temp=XCmean(NC>=TH,91);
figure;hold on;set(gca,'xscale','log');
for i=1:size(WHO_acc,1)
    semilogx(WHO_acc(i,3),temp(i),'ks','MarkerFaceColor','none','MarkerEdgeColor',[0 0 1],'Markersize',10,'Linewidth',1.2)
end
h=findobj('FontName','Helvetica'); set(h,'FontSize',20,'Fontname','Arial')
xlabel('GDP per capita (US$, log scale)');ylabel('Mean thrill seeking score')
axis([500 100000 -1 1])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial')
grid on;box on;axis square
set(gca,'LooseInset', [0.01 0.01 0.10 0.01]);
saveas(gcf,'Figure_GDPcapita_vs_thrillseeking','fig');
%% Figure 3 left. Scatter plot of GPD per capita versus mean self-reported monthly household income
temp=XCmean(NC>=TH,55);
figure;hold on;set(gca,'xscale','log');
for i=1:size(WHO_acc,1)
    semilogx(WHO_acc(i,3),temp(i),'ks','MarkerFaceColor','none','MarkerEdgeColor',[0 0 1],'Markersize',10,'Linewidth',1.2)
end
h=findobj('FontName','Helvetica'); set(h,'FontSize',20,'Fontname','Arial')
xlabel('GDP per capita (US$, log scale)');ylabel('Mean self-reported monthly household income (1-6)')
axis([500 100000 1 4])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial')
grid on;box on;axis square
set(gca,'LooseInset', [0.01 0.01 0.10 0.01]);
saveas(gcf,'Figure_GDPcapita_vs_income','fig');
%% Figure 3 right. Scatter plot of GPD per capita versus median self-reported yearly mileage
temp=XCmed(NC>=TH,65);
figure;hold on;set(gca,'xscale','log');
for i=1:size(WHO_acc,1)
    loglog(WHO_acc(i,3),temp(i),'ks','MarkerFaceColor','none','MarkerEdgeColor',[0 0 1],'Markersize',10,'Linewidth',1.2)
end
h=findobj('FontName','Helvetica'); set(h,'FontSize',20,'Fontname','Arial')
xlabel('GDP per capita (US$, log scale)');ylabel('Median self-reported yearly mileage (miles)')
axis([500 100000 0 11000])
fig=gcf;set(findall(fig,'-property','FontName'),'FontName','Arial')
grid on;box on;axis square
set(gca,'LooseInset', [0.01 0.01 0.10 0.01]);
saveas(gcf,'Figure_GDPcapita_vs_mileage','fig');
%%
clc
CMATR=[XCmean(NC>=TH,89:94) WHO_acc(:,1) WHO_acc(:,3) COGN LIFE VEH AGE];
[c_CMATR,p_CMATR]=corr(CMATR,'type','spearman','rows','pairwise');
M='1.GAC 2.PCA1 3.PCA2 4.PCA3 5.PCA4 6.PCA5 7.AccPopul 8.GDPcap 9.EducPerf 10.LifeExpec 11.VehicleDens 12.MedAge';
printmat(round(c_CMATR*100)/100,'Correlation matrix at the country level', M,M)
disp('Sample sizes of variables of national matrix')
disp(sum(~isnan(CMATR)))
%%
Easeofuse=[22 25]; % 2 items X
Enjoymanual=[9 16 17 34]; % 4 items X
Enjoymentoftechnology=[21 46 48]; % 3 items X
Futureorientation=[51 85 86 87]; % 4 items X
Intentiontouse=[12 31 38 39 41 43 45 74 83]; % 9 items X
Knowledgeofmobility=[13 18 19 37 49]; % 5 items X
Likingofbeingincontrol=[7 32 36 54 64]; % 5 items X
Miscellaneous=[10 11 20]; % 3 items
Pleasure=[23 30]; % 2 items X
Satisfactiondailytravel=[14 15]; % 2 items X
Skeptical=[8 29 40 53]; % 4 items X
Socialinfluence=[33 50]; % 2 items X
Trust=[26 27 28 42]; % 4 items X
Usefulness=[24 44]; % 2 items X
Wishforcarfreefuture=[35 47 67 68 69 70 84]; % 7 items X

disp((mean(lding_X(Skeptical))))
disp((mean(lding_X(Satisfactiondailytravel))))
disp((mean(lding_X(Enjoymanual))))
disp((mean(lding_X(Likingofbeingincontrol))))
disp((mean(lding_X(Wishforcarfreefuture))))
disp((mean(lding_X(Futureorientation))))
disp((mean(lding_X(Enjoymentoftechnology))))
disp((mean(lding_X(Socialinfluence))))
disp((mean(lding_X(Intentiontouse))))
disp((mean(lding_X(Knowledgeofmobility))))
disp((mean(lding_X(Pleasure))))
disp((mean(lding_X(Trust))))
disp((mean(lding_X(Easeofuse))))
disp((mean(lding_X(Usefulness))))